#ifndef DOMAINMODEL_H
#define DOMAINMODEL_H
#include <Wt/WAbstractItemModel>
#include <boost/shared_ptr.hpp>
using namespace Wt;
class NodeItem;
class Model : public WAbstractItemModel
{
  boost::shared_ptr<NodeItem> root;
public:
  Model( WObject *parent = NULL );
  virtual ~Model();
  virtual int columnCount       ( const WModelIndex& parent = WModelIndex() ) const;
  virtual int rowCount          ( const WModelIndex& parent = WModelIndex() ) const ;
  virtual WModelIndex parent    ( const WModelIndex& index ) const;
  virtual boost::any data       ( const WModelIndex& index, int role ) const;
  virtual WModelIndex index     ( int row, int column, const WModelIndex& parent = WModelIndex() )const;
  void    addObject( NodeItem* parent = NULL );
  void    remObject(NodeItem* item );
};


#endif // DOMAINMODEL_H
