#ifndef NODEITEM_H
#define NODEITEM_H
#include <vector>
#include <string>
class NodeItem
{
  NodeItem               *parent;
  std::vector<NodeItem*>  childs;
public:
  int                     sourceIdx;
  NodeItem( NodeItem *parent_ = NULL );
  ~NodeItem();
  size_t    rowCount() const;
  NodeItem* parentItem() const;
  size_t    row() const;
  NodeItem* child( size_t row );
  void      clearChilds();
};
#endif // NODEITEM_H
